/* ***********************************************************
 * This file was automatically generated on 2012-09-26.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

#include "bricklet_linear_poti.h"

#include <string.h>

#define FUNCTION_GET_POSITION 1
#define FUNCTION_GET_ANALOG_VALUE 2
#define FUNCTION_SET_POSITION_CALLBACK_PERIOD 3
#define FUNCTION_GET_POSITION_CALLBACK_PERIOD 4
#define FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD 5
#define FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD 6
#define FUNCTION_SET_POSITION_CALLBACK_THRESHOLD 7
#define FUNCTION_GET_POSITION_CALLBACK_THRESHOLD 8
#define FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD 9
#define FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD 10
#define FUNCTION_SET_DEBOUNCE_PERIOD 11
#define FUNCTION_GET_DEBOUNCE_PERIOD 12


typedef void (*position_func_t)(uint16_t);

typedef void (*analog_value_func_t)(uint16_t);

typedef void (*position_reached_func_t)(uint16_t);

typedef void (*analog_value_reached_func_t)(uint16_t);

#if defined _MSC_VER || defined __BORLANDC__
	#pragma pack(push)
	#pragma pack(1)
	#define ATTRIBUTE_PACKED
#elif defined __GNUC__
	#define ATTRIBUTE_PACKED __attribute__((packed))
#else
	#error unknown compiler, do not know how to enable struct packing
#endif

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
} ATTRIBUTE_PACKED GetPosition_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint16_t position;
} ATTRIBUTE_PACKED GetPositionReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
} ATTRIBUTE_PACKED GetAnalogValue_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint16_t value;
} ATTRIBUTE_PACKED GetAnalogValueReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint32_t period;
} ATTRIBUTE_PACKED SetPositionCallbackPeriod_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
} ATTRIBUTE_PACKED GetPositionCallbackPeriod_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint32_t period;
} ATTRIBUTE_PACKED GetPositionCallbackPeriodReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint32_t period;
} ATTRIBUTE_PACKED SetAnalogValueCallbackPeriod_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
} ATTRIBUTE_PACKED GetAnalogValueCallbackPeriod_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint32_t period;
} ATTRIBUTE_PACKED GetAnalogValueCallbackPeriodReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	char option;
	int16_t min;
	int16_t max;
} ATTRIBUTE_PACKED SetPositionCallbackThreshold_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
} ATTRIBUTE_PACKED GetPositionCallbackThreshold_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	char option;
	int16_t min;
	int16_t max;
} ATTRIBUTE_PACKED GetPositionCallbackThresholdReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	char option;
	uint16_t min;
	uint16_t max;
} ATTRIBUTE_PACKED SetAnalogValueCallbackThreshold_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
} ATTRIBUTE_PACKED GetAnalogValueCallbackThreshold_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	char option;
	uint16_t min;
	uint16_t max;
} ATTRIBUTE_PACKED GetAnalogValueCallbackThresholdReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint32_t debounce;
} ATTRIBUTE_PACKED SetDebouncePeriod_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
} ATTRIBUTE_PACKED GetDebouncePeriod_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint32_t debounce;
} ATTRIBUTE_PACKED GetDebouncePeriodReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint16_t position;
} ATTRIBUTE_PACKED PositionCallback_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint16_t value;
} ATTRIBUTE_PACKED AnalogValueCallback_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint16_t position;
} ATTRIBUTE_PACKED PositionReachedCallback_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint16_t value;
} ATTRIBUTE_PACKED AnalogValueReachedCallback_;

#if defined _MSC_VER || defined __BORLANDC__
	#pragma pack(pop)
#endif
#undef ATTRIBUTE_PACKED

int linear_poti_get_position(LinearPoti *linear_poti, uint16_t *ret_position) {
	if(linear_poti->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&linear_poti->write_mutex);

	linear_poti->response.function_id = FUNCTION_GET_POSITION;
	linear_poti->response.length = sizeof(GetPositionReturn_);
	GetPosition_ gp;
	gp.stack_id = linear_poti->stack_id;
	gp.function_id = FUNCTION_GET_POSITION;
	gp.length = ipcon_leconvert_uint16_to(sizeof(GetPosition_));

	ipcon_device_write(linear_poti, (char *)&gp, sizeof(GetPosition_));

	if(ipcon_device_expect_response(linear_poti) != 0) {
		ipcon_mutex_unlock(&linear_poti->write_mutex);
		return E_TIMEOUT;
	}

	GetPositionReturn_ *gpr = (GetPositionReturn_ *)linear_poti->response.buffer;
	*ret_position = ipcon_leconvert_uint16_from(gpr->position);

	ipcon_mutex_unlock(&linear_poti->write_mutex);

	return E_OK;
}

int linear_poti_get_analog_value(LinearPoti *linear_poti, uint16_t *ret_value) {
	if(linear_poti->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&linear_poti->write_mutex);

	linear_poti->response.function_id = FUNCTION_GET_ANALOG_VALUE;
	linear_poti->response.length = sizeof(GetAnalogValueReturn_);
	GetAnalogValue_ gav;
	gav.stack_id = linear_poti->stack_id;
	gav.function_id = FUNCTION_GET_ANALOG_VALUE;
	gav.length = ipcon_leconvert_uint16_to(sizeof(GetAnalogValue_));

	ipcon_device_write(linear_poti, (char *)&gav, sizeof(GetAnalogValue_));

	if(ipcon_device_expect_response(linear_poti) != 0) {
		ipcon_mutex_unlock(&linear_poti->write_mutex);
		return E_TIMEOUT;
	}

	GetAnalogValueReturn_ *gavr = (GetAnalogValueReturn_ *)linear_poti->response.buffer;
	*ret_value = ipcon_leconvert_uint16_from(gavr->value);

	ipcon_mutex_unlock(&linear_poti->write_mutex);

	return E_OK;
}

int linear_poti_set_position_callback_period(LinearPoti *linear_poti, uint32_t period) {
	if(linear_poti->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&linear_poti->write_mutex);

	SetPositionCallbackPeriod_ spcp;
	spcp.stack_id = linear_poti->stack_id;
	spcp.function_id = FUNCTION_SET_POSITION_CALLBACK_PERIOD;
	spcp.length = ipcon_leconvert_uint16_to(sizeof(SetPositionCallbackPeriod_));
	spcp.period = ipcon_leconvert_uint32_to(period);

	ipcon_device_write(linear_poti, (char *)&spcp, sizeof(SetPositionCallbackPeriod_));

	ipcon_mutex_unlock(&linear_poti->write_mutex);

	return E_OK;
}

int linear_poti_get_position_callback_period(LinearPoti *linear_poti, uint32_t *ret_period) {
	if(linear_poti->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&linear_poti->write_mutex);

	linear_poti->response.function_id = FUNCTION_GET_POSITION_CALLBACK_PERIOD;
	linear_poti->response.length = sizeof(GetPositionCallbackPeriodReturn_);
	GetPositionCallbackPeriod_ gpcp;
	gpcp.stack_id = linear_poti->stack_id;
	gpcp.function_id = FUNCTION_GET_POSITION_CALLBACK_PERIOD;
	gpcp.length = ipcon_leconvert_uint16_to(sizeof(GetPositionCallbackPeriod_));

	ipcon_device_write(linear_poti, (char *)&gpcp, sizeof(GetPositionCallbackPeriod_));

	if(ipcon_device_expect_response(linear_poti) != 0) {
		ipcon_mutex_unlock(&linear_poti->write_mutex);
		return E_TIMEOUT;
	}

	GetPositionCallbackPeriodReturn_ *gpcpr = (GetPositionCallbackPeriodReturn_ *)linear_poti->response.buffer;
	*ret_period = ipcon_leconvert_uint32_from(gpcpr->period);

	ipcon_mutex_unlock(&linear_poti->write_mutex);

	return E_OK;
}

int linear_poti_set_analog_value_callback_period(LinearPoti *linear_poti, uint32_t period) {
	if(linear_poti->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&linear_poti->write_mutex);

	SetAnalogValueCallbackPeriod_ savcp;
	savcp.stack_id = linear_poti->stack_id;
	savcp.function_id = FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD;
	savcp.length = ipcon_leconvert_uint16_to(sizeof(SetAnalogValueCallbackPeriod_));
	savcp.period = ipcon_leconvert_uint32_to(period);

	ipcon_device_write(linear_poti, (char *)&savcp, sizeof(SetAnalogValueCallbackPeriod_));

	ipcon_mutex_unlock(&linear_poti->write_mutex);

	return E_OK;
}

int linear_poti_get_analog_value_callback_period(LinearPoti *linear_poti, uint32_t *ret_period) {
	if(linear_poti->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&linear_poti->write_mutex);

	linear_poti->response.function_id = FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD;
	linear_poti->response.length = sizeof(GetAnalogValueCallbackPeriodReturn_);
	GetAnalogValueCallbackPeriod_ gavcp;
	gavcp.stack_id = linear_poti->stack_id;
	gavcp.function_id = FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD;
	gavcp.length = ipcon_leconvert_uint16_to(sizeof(GetAnalogValueCallbackPeriod_));

	ipcon_device_write(linear_poti, (char *)&gavcp, sizeof(GetAnalogValueCallbackPeriod_));

	if(ipcon_device_expect_response(linear_poti) != 0) {
		ipcon_mutex_unlock(&linear_poti->write_mutex);
		return E_TIMEOUT;
	}

	GetAnalogValueCallbackPeriodReturn_ *gavcpr = (GetAnalogValueCallbackPeriodReturn_ *)linear_poti->response.buffer;
	*ret_period = ipcon_leconvert_uint32_from(gavcpr->period);

	ipcon_mutex_unlock(&linear_poti->write_mutex);

	return E_OK;
}

int linear_poti_set_position_callback_threshold(LinearPoti *linear_poti, char option, int16_t min, int16_t max) {
	if(linear_poti->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&linear_poti->write_mutex);

	SetPositionCallbackThreshold_ spct;
	spct.stack_id = linear_poti->stack_id;
	spct.function_id = FUNCTION_SET_POSITION_CALLBACK_THRESHOLD;
	spct.length = ipcon_leconvert_uint16_to(sizeof(SetPositionCallbackThreshold_));
	spct.option = option;
	spct.min = ipcon_leconvert_int16_to(min);
	spct.max = ipcon_leconvert_int16_to(max);

	ipcon_device_write(linear_poti, (char *)&spct, sizeof(SetPositionCallbackThreshold_));

	ipcon_mutex_unlock(&linear_poti->write_mutex);

	return E_OK;
}

int linear_poti_get_position_callback_threshold(LinearPoti *linear_poti, char *ret_option, int16_t *ret_min, int16_t *ret_max) {
	if(linear_poti->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&linear_poti->write_mutex);

	linear_poti->response.function_id = FUNCTION_GET_POSITION_CALLBACK_THRESHOLD;
	linear_poti->response.length = sizeof(GetPositionCallbackThresholdReturn_);
	GetPositionCallbackThreshold_ gpct;
	gpct.stack_id = linear_poti->stack_id;
	gpct.function_id = FUNCTION_GET_POSITION_CALLBACK_THRESHOLD;
	gpct.length = ipcon_leconvert_uint16_to(sizeof(GetPositionCallbackThreshold_));

	ipcon_device_write(linear_poti, (char *)&gpct, sizeof(GetPositionCallbackThreshold_));

	if(ipcon_device_expect_response(linear_poti) != 0) {
		ipcon_mutex_unlock(&linear_poti->write_mutex);
		return E_TIMEOUT;
	}

	GetPositionCallbackThresholdReturn_ *gpctr = (GetPositionCallbackThresholdReturn_ *)linear_poti->response.buffer;
	*ret_option = gpctr->option;
	*ret_min = ipcon_leconvert_int16_from(gpctr->min);
	*ret_max = ipcon_leconvert_int16_from(gpctr->max);

	ipcon_mutex_unlock(&linear_poti->write_mutex);

	return E_OK;
}

int linear_poti_set_analog_value_callback_threshold(LinearPoti *linear_poti, char option, uint16_t min, uint16_t max) {
	if(linear_poti->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&linear_poti->write_mutex);

	SetAnalogValueCallbackThreshold_ savct;
	savct.stack_id = linear_poti->stack_id;
	savct.function_id = FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD;
	savct.length = ipcon_leconvert_uint16_to(sizeof(SetAnalogValueCallbackThreshold_));
	savct.option = option;
	savct.min = ipcon_leconvert_uint16_to(min);
	savct.max = ipcon_leconvert_uint16_to(max);

	ipcon_device_write(linear_poti, (char *)&savct, sizeof(SetAnalogValueCallbackThreshold_));

	ipcon_mutex_unlock(&linear_poti->write_mutex);

	return E_OK;
}

int linear_poti_get_analog_value_callback_threshold(LinearPoti *linear_poti, char *ret_option, uint16_t *ret_min, uint16_t *ret_max) {
	if(linear_poti->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&linear_poti->write_mutex);

	linear_poti->response.function_id = FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD;
	linear_poti->response.length = sizeof(GetAnalogValueCallbackThresholdReturn_);
	GetAnalogValueCallbackThreshold_ gavct;
	gavct.stack_id = linear_poti->stack_id;
	gavct.function_id = FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD;
	gavct.length = ipcon_leconvert_uint16_to(sizeof(GetAnalogValueCallbackThreshold_));

	ipcon_device_write(linear_poti, (char *)&gavct, sizeof(GetAnalogValueCallbackThreshold_));

	if(ipcon_device_expect_response(linear_poti) != 0) {
		ipcon_mutex_unlock(&linear_poti->write_mutex);
		return E_TIMEOUT;
	}

	GetAnalogValueCallbackThresholdReturn_ *gavctr = (GetAnalogValueCallbackThresholdReturn_ *)linear_poti->response.buffer;
	*ret_option = gavctr->option;
	*ret_min = ipcon_leconvert_uint16_from(gavctr->min);
	*ret_max = ipcon_leconvert_uint16_from(gavctr->max);

	ipcon_mutex_unlock(&linear_poti->write_mutex);

	return E_OK;
}

int linear_poti_set_debounce_period(LinearPoti *linear_poti, uint32_t debounce) {
	if(linear_poti->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&linear_poti->write_mutex);

	SetDebouncePeriod_ sdp;
	sdp.stack_id = linear_poti->stack_id;
	sdp.function_id = FUNCTION_SET_DEBOUNCE_PERIOD;
	sdp.length = ipcon_leconvert_uint16_to(sizeof(SetDebouncePeriod_));
	sdp.debounce = ipcon_leconvert_uint32_to(debounce);

	ipcon_device_write(linear_poti, (char *)&sdp, sizeof(SetDebouncePeriod_));

	ipcon_mutex_unlock(&linear_poti->write_mutex);

	return E_OK;
}

int linear_poti_get_debounce_period(LinearPoti *linear_poti, uint32_t *ret_debounce) {
	if(linear_poti->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&linear_poti->write_mutex);

	linear_poti->response.function_id = FUNCTION_GET_DEBOUNCE_PERIOD;
	linear_poti->response.length = sizeof(GetDebouncePeriodReturn_);
	GetDebouncePeriod_ gdp;
	gdp.stack_id = linear_poti->stack_id;
	gdp.function_id = FUNCTION_GET_DEBOUNCE_PERIOD;
	gdp.length = ipcon_leconvert_uint16_to(sizeof(GetDebouncePeriod_));

	ipcon_device_write(linear_poti, (char *)&gdp, sizeof(GetDebouncePeriod_));

	if(ipcon_device_expect_response(linear_poti) != 0) {
		ipcon_mutex_unlock(&linear_poti->write_mutex);
		return E_TIMEOUT;
	}

	GetDebouncePeriodReturn_ *gdpr = (GetDebouncePeriodReturn_ *)linear_poti->response.buffer;
	*ret_debounce = ipcon_leconvert_uint32_from(gdpr->debounce);

	ipcon_mutex_unlock(&linear_poti->write_mutex);

	return E_OK;
}

int linear_poti_get_version(LinearPoti *linear_poti, char ret_name[40], uint8_t ret_firmware_version[3], uint8_t ret_binding_version[3]) {
	strncpy(ret_name, linear_poti->name, 40);

	ret_firmware_version[0] = linear_poti->firmware_version[0];
	ret_firmware_version[1] = linear_poti->firmware_version[1];
	ret_firmware_version[2] = linear_poti->firmware_version[2];

	ret_binding_version[0] = linear_poti->binding_version[0];
	ret_binding_version[1] = linear_poti->binding_version[1];
	ret_binding_version[2] = linear_poti->binding_version[2];

	return E_OK;
}

static int linear_poti_callback_wrapper_position(LinearPoti *linear_poti, const unsigned char *buffer) {
	PositionCallback_ *pc = (PositionCallback_ *)buffer;
	pc->position = ipcon_leconvert_uint16_from(pc->position);
	((position_func_t)linear_poti->registered_callbacks[pc->function_id])(pc->position);
	return sizeof(PositionCallback_);
}

static int linear_poti_callback_wrapper_analog_value(LinearPoti *linear_poti, const unsigned char *buffer) {
	AnalogValueCallback_ *avc = (AnalogValueCallback_ *)buffer;
	avc->value = ipcon_leconvert_uint16_from(avc->value);
	((analog_value_func_t)linear_poti->registered_callbacks[avc->function_id])(avc->value);
	return sizeof(AnalogValueCallback_);
}

static int linear_poti_callback_wrapper_position_reached(LinearPoti *linear_poti, const unsigned char *buffer) {
	PositionReachedCallback_ *prc = (PositionReachedCallback_ *)buffer;
	prc->position = ipcon_leconvert_uint16_from(prc->position);
	((position_reached_func_t)linear_poti->registered_callbacks[prc->function_id])(prc->position);
	return sizeof(PositionReachedCallback_);
}

static int linear_poti_callback_wrapper_analog_value_reached(LinearPoti *linear_poti, const unsigned char *buffer) {
	AnalogValueReachedCallback_ *avrc = (AnalogValueReachedCallback_ *)buffer;
	avrc->value = ipcon_leconvert_uint16_from(avrc->value);
	((analog_value_reached_func_t)linear_poti->registered_callbacks[avrc->function_id])(avrc->value);
	return sizeof(AnalogValueReachedCallback_);
}

void linear_poti_register_callback(LinearPoti *linear_poti, uint8_t id, void *callback) {
	linear_poti->registered_callbacks[id] = callback;
}

void linear_poti_create(LinearPoti *linear_poti, const char *uid) {
	ipcon_device_create(linear_poti, uid);

	linear_poti->expected_name = "Linear Poti Bricklet";

	linear_poti->binding_version[0] = 1;
	linear_poti->binding_version[1] = 0;
	linear_poti->binding_version[2] = 0;

	linear_poti->callback_wrappers[LINEAR_POTI_CALLBACK_POSITION] = linear_poti_callback_wrapper_position;
	linear_poti->callback_wrappers[LINEAR_POTI_CALLBACK_ANALOG_VALUE] = linear_poti_callback_wrapper_analog_value;
	linear_poti->callback_wrappers[LINEAR_POTI_CALLBACK_POSITION_REACHED] = linear_poti_callback_wrapper_position_reached;
	linear_poti->callback_wrappers[LINEAR_POTI_CALLBACK_ANALOG_VALUE_REACHED] = linear_poti_callback_wrapper_analog_value_reached;
}
